<?xml version="1.0" encoding="UTF-8"?><!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Strict//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-strict.dtd"><html xmlns="http://www.w3.org/1999/xhtml" lang="en"><head><meta http-equiv="Content-Type" content="text/html;charset=UTF-8"/><link rel="stylesheet" href="../jacoco-resources/report.css" type="text/css"/><link rel="shortcut icon" href="../jacoco-resources/report.gif" type="image/gif"/><title>Login.java</title><link rel="stylesheet" href="../jacoco-resources/prettify.css" type="text/css"/><script type="text/javascript" src="../jacoco-resources/prettify.js"></script></head><body onload="window['PR_TAB_WIDTH']=4;prettyPrint()"><div class="breadcrumb" id="breadcrumb"><span class="info"><a href="../jacoco-sessions.html" class="el_session">Sessions</a></span><a href="../index.html" class="el_report">Code Coverage for Zookeeper manuall provided Classes</a> &gt; <a href="index.source.html" class="el_package">org.apache.zookeeper</a> &gt; <span class="el_source">Login.java</span></div><h1>Login.java</h1><pre class="source lang-java linenums">/**
 * Licensed to the Apache Software Foundation (ASF) under one
 * or more contributor license agreements.  See the NOTICE file
 * distributed with this work for additional information
 * regarding copyright ownership.  The ASF licenses this file
 * to you under the Apache License, Version 2.0 (the
 * &quot;License&quot;); you may not use this file except in compliance
 * with the License.  You may obtain a copy of the License at
 *
 *     http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an &quot;AS IS&quot; BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */

package org.apache.zookeeper;

/** 
 * This class is responsible for refreshing Kerberos credentials for
 * logins for both Zookeeper client and server.
 * See ZooKeeperSaslServer for server-side usage.
 * See ZooKeeperSaslClient for client-side usage.
 */

import javax.security.auth.kerberos.KerberosPrincipal;
import javax.security.auth.login.AppConfigurationEntry;
import javax.security.auth.login.Configuration;
import javax.security.auth.login.LoginContext;
import javax.security.auth.login.LoginException;
import javax.security.auth.callback.CallbackHandler;

import org.apache.log4j.Logger;
import org.apache.zookeeper.client.ZooKeeperSaslClient;
import javax.security.auth.kerberos.KerberosTicket;
import javax.security.auth.Subject;
import java.util.Date;
import java.util.Random;
import java.util.Set;

public class Login {
<span class="fc" id="L44">    Logger LOG = Logger.getLogger(Login.class);</span>
    public CallbackHandler callbackHandler;

    // LoginThread will sleep until 80% of time from last refresh to
    // ticket's expiry has been reached, at which time it will wake
    // and try to renew the ticket.
    private static final float TICKET_RENEW_WINDOW = 0.80f;

    /**
     * Percentage of random jitter added to the renewal time
     */
    private static final float TICKET_RENEW_JITTER = 0.05f;

    // Regardless of TICKET_RENEW_WINDOW setting above and the ticket expiry time,
    // thread will not sleep between refresh attempts any less than 1 minute (60*1000 milliseconds = 1 minute).
    // Change the '1' to e.g. 5, to change this to 5 minutes.
    private static final long MIN_TIME_BEFORE_RELOGIN = 1 * 60 * 1000L;

<span class="fc" id="L62">    private Subject subject = null;</span>
<span class="fc" id="L63">    private Thread t = null;</span>
<span class="fc" id="L64">    private boolean isKrbTicket = false;</span>
<span class="fc" id="L65">    private boolean isUsingTicketCache = false;</span>
<span class="fc" id="L66">    private boolean isUsingKeytab = false;</span>

    /** Random number generator */
<span class="fc" id="L69">    private static Random rng = new Random();</span>

<span class="fc" id="L71">    private LoginContext login = null;</span>
<span class="fc" id="L72">    private String loginContextName = null;</span>
<span class="fc" id="L73">    private String keytabFile = null;</span>
<span class="fc" id="L74">    private String principal = null;</span>

<span class="fc" id="L76">    private long lastLogin = 0;</span>

    /**
     * LoginThread constructor. The constructor starts the thread used
     * to periodically re-login to the Kerberos Ticket Granting Server.
     * @param loginContextName
     *               name of section in JAAS file that will be use to login.
     *               Passed as first param to javax.security.auth.login.LoginContext().
     *
     * @param callbackHandler
     *               Passed as second param to javax.security.auth.login.LoginContext().
     * @throws javax.security.auth.login.LoginException
     *               Thrown if authentication fails.
     */
    public Login(final String loginContextName, CallbackHandler callbackHandler)
<span class="fc" id="L91">            throws LoginException {</span>
<span class="fc" id="L92">        this.callbackHandler = callbackHandler;</span>
<span class="fc" id="L93">        login = login(loginContextName);</span>
<span class="fc" id="L94">        this.loginContextName = loginContextName;</span>
<span class="fc" id="L95">        subject = login.getSubject();</span>
<span class="pc bpc" id="L96" title="1 of 2 branches missed.">        isKrbTicket = !subject.getPrivateCredentials(KerberosTicket.class).isEmpty();</span>
<span class="fc" id="L97">        AppConfigurationEntry entries[] = Configuration.getConfiguration().getAppConfigurationEntry(loginContextName);</span>
<span class="pc bpc" id="L98" title="1 of 2 branches missed.">        for (AppConfigurationEntry entry: entries) {</span>
            // there will only be a single entry, so this for() loop will only be iterated through once.
<span class="pc bpc" id="L100" title="1 of 2 branches missed.">            if (entry.getOptions().get(&quot;useTicketCache&quot;) != null) {</span>
<span class="nc" id="L101">                String val = (String)entry.getOptions().get(&quot;useTicketCache&quot;);</span>
<span class="nc bnc" id="L102" title="All 2 branches missed.">                if (val.equals(&quot;true&quot;)) {</span>
<span class="nc" id="L103">                    isUsingTicketCache = true;</span>
                }
            }
<span class="pc bpc" id="L106" title="1 of 2 branches missed.">            if (entry.getOptions().get(&quot;keyTab&quot;) != null) {</span>
<span class="nc" id="L107">                keytabFile = (String)entry.getOptions().get(&quot;keyTab&quot;);</span>
<span class="nc" id="L108">                isUsingKeytab = true;</span>
            }
<span class="pc bpc" id="L110" title="1 of 2 branches missed.">            if (entry.getOptions().get(&quot;principal&quot;) != null) {</span>
<span class="nc" id="L111">                principal = (String)entry.getOptions().get(&quot;principal&quot;);</span>
            }
            break;
        }

<span class="pc bpc" id="L116" title="1 of 2 branches missed.">        if (!isKrbTicket) {</span>
            // if no TGT, do not bother with ticket management.
<span class="fc" id="L118">            return;</span>
        }

        // Refresh the Ticket Granting Ticket (TGT) periodically. How often to refresh is determined by the
        // TGT's existing expiry date and the configured MIN_TIME_BEFORE_RELOGIN. For testing and development,
        // you can decrease the interval of expiration of tickets (for example, to 3 minutes) by running :
        //  &quot;modprinc -maxlife 3mins &lt;principal&gt;&quot; in kadmin.
<span class="nc" id="L125">        t = new Thread(new Runnable() {</span>
            public void run() {
<span class="nc" id="L127">                LOG.info(&quot;TGT refresh thread started.&quot;);</span>
                while (true) {  // renewal thread's main loop. if it exits from here, thread will exit.
<span class="nc" id="L129">                    KerberosTicket tgt = getTGT();</span>
<span class="nc" id="L130">                    long now = System.currentTimeMillis();</span>
                    long nextRefresh;
                    Date nextRefreshDate;
<span class="nc bnc" id="L133" title="All 2 branches missed.">                    if (tgt == null) {</span>
<span class="nc" id="L134">                        nextRefresh = now + MIN_TIME_BEFORE_RELOGIN;</span>
<span class="nc" id="L135">                        nextRefreshDate = new Date(nextRefresh);</span>
<span class="nc" id="L136">                        LOG.warn(&quot;No TGT found: will try again at &quot; + nextRefreshDate);</span>
                    } else {
<span class="nc" id="L138">                        nextRefresh = getRefreshTime(tgt);</span>
<span class="nc" id="L139">                        long expiry = tgt.getEndTime().getTime();</span>
<span class="nc" id="L140">                        Date expiryDate = new Date(expiry);</span>
<span class="nc bnc" id="L141" title="All 4 branches missed.">                        if ((isUsingTicketCache) &amp;&amp; (tgt.getEndTime().equals(tgt.getRenewTill()))) {</span>
<span class="nc" id="L142">                            LOG.error(&quot;The TGT cannot be renewed beyond the next expiry date: &quot; + expiryDate + &quot;.&quot; +</span>
                                    &quot;This process will not be able to authenticate new SASL connections after that &quot; +
                                    &quot;time (for example, it will not be authenticate a new connection with a Zookeeper &quot; +
                                    &quot;Quorum member).  Ask your system administrator to either increase the &quot; +
<span class="nc" id="L146">                                    &quot;'renew until' time by doing : 'modprinc -maxrenewlife &quot; + principal + &quot;' within &quot; +</span>
<span class="nc" id="L147">                                    &quot;kadmin, or instead, to generate a keytab for &quot; + principal + &quot;. Because the TGT's &quot; +</span>
                                    &quot;expiry cannot be further extended by refreshing, exiting refresh thread now.&quot;);
<span class="nc" id="L149">                            return;</span>
                        }
                        // determine how long to sleep from looking at ticket's expiry.
                        // We should not allow the ticket to expire, but we should take into consideration
                        // MIN_TIME_BEFORE_RELOGIN. Will not sleep less than MIN_TIME_BEFORE_RELOGIN, unless doing so
                        // would cause ticket expiration.
<span class="nc bnc" id="L155" title="All 4 branches missed.">                        if ((nextRefresh &gt; expiry) ||</span>
                                ((now + MIN_TIME_BEFORE_RELOGIN) &gt; expiry)) {
                            // expiry is before next scheduled refresh).
<span class="nc" id="L158">                            nextRefresh = now;</span>
                        } else {
<span class="nc bnc" id="L160" title="All 2 branches missed.">                            if (nextRefresh &lt; (now + MIN_TIME_BEFORE_RELOGIN)) {</span>
                                // next scheduled refresh is sooner than (now + MIN_TIME_BEFORE_LOGIN).
<span class="nc" id="L162">                                Date until = new Date(nextRefresh);</span>
<span class="nc" id="L163">                                Date newuntil = new Date(now + MIN_TIME_BEFORE_RELOGIN);</span>
<span class="nc" id="L164">                                LOG.warn(&quot;TGT refresh thread time adjusted from : &quot; + until + &quot; to : &quot; + newuntil + &quot; since &quot;</span>
                                        + &quot;the former is sooner than the minimum refresh interval (&quot;
                                        + MIN_TIME_BEFORE_RELOGIN / 1000 + &quot; seconds) from now.&quot;);
                            }
<span class="nc" id="L168">                            nextRefresh = Math.max(nextRefresh, now + MIN_TIME_BEFORE_RELOGIN);</span>
                        }
<span class="nc" id="L170">                        nextRefreshDate = new Date(nextRefresh);</span>
<span class="nc bnc" id="L171" title="All 2 branches missed.">                        if (nextRefresh &gt; expiry) {</span>
<span class="nc" id="L172">                            LOG.error(&quot;next refresh: &quot; + nextRefreshDate + &quot; is later than expiry &quot; + expiryDate</span>
                                    + &quot;. This may indicate a clock skew problem. Check that this host and the KDC's &quot;
                                    + &quot;hosts' clocks are in sync. Exiting refresh thread.&quot;);
<span class="nc" id="L175">                            return;</span>
                        }
                    }
<span class="nc bnc" id="L178" title="All 2 branches missed.">                    if (now == nextRefresh) {</span>
<span class="nc" id="L179">                        LOG.info(&quot;refreshing now because expiry is before next scheduled refresh time.&quot;);</span>
<span class="nc bnc" id="L180" title="All 2 branches missed.">                    } else if (now &lt; nextRefresh) {</span>
<span class="nc" id="L181">                        Date until = new Date(nextRefresh);</span>
<span class="nc" id="L182">                        LOG.info(&quot;TGT refresh sleeping until: &quot; + until.toString());</span>
                        try {
<span class="nc" id="L184">                            Thread.sleep(nextRefresh - now);</span>
<span class="nc" id="L185">                        } catch (InterruptedException ie) {</span>
<span class="nc" id="L186">                            LOG.warn(&quot;TGT renewal thread has been interrupted and will exit.&quot;);</span>
<span class="nc" id="L187">                            break;</span>
<span class="nc" id="L188">                        }</span>
<span class="nc" id="L189">                    }</span>
                    else {
<span class="nc" id="L191">                        LOG.error(&quot;nextRefresh:&quot; + nextRefreshDate + &quot; is in the past: exiting refresh thread. Check&quot;</span>
                                + &quot; clock sync between this host and KDC - (KDC's clock is likely ahead of this host).&quot;
                                + &quot; Manual intervention will be required for this client to successfully authenticate.&quot;
                                + &quot; Exiting refresh thread.&quot;);
<span class="nc" id="L195">                        break;</span>
                    }
<span class="nc bnc" id="L197" title="All 2 branches missed.">                    if (isUsingTicketCache) {</span>
<span class="nc" id="L198">                        String cmd = &quot;/usr/bin/kinit&quot;;</span>
<span class="nc bnc" id="L199" title="All 2 branches missed.">                        if (System.getProperty(&quot;zookeeper.kinit&quot;) != null) {</span>
<span class="nc" id="L200">                            cmd = System.getProperty(&quot;zookeeper.kinit&quot;);</span>
                        }
<span class="nc" id="L202">                        String kinitArgs = &quot;-R&quot;;</span>
<span class="nc" id="L203">                        int retry = 1;</span>
<span class="nc bnc" id="L204" title="All 2 branches missed.">                        while (retry &gt;= 0) {</span>
                            try {
<span class="nc" id="L206">                                LOG.debug(&quot;running ticket cache refresh command: &quot; + cmd + &quot; &quot; + kinitArgs);</span>
<span class="nc" id="L207">                                Shell.execCommand(cmd, kinitArgs);</span>
<span class="nc" id="L208">                                break;</span>
<span class="nc" id="L209">                            } catch (Exception e) {</span>
<span class="nc bnc" id="L210" title="All 2 branches missed.">                                if (retry &gt; 0) {</span>
<span class="nc" id="L211">                                    --retry;</span>
                                    // sleep for 10 seconds
                                    try {
<span class="nc" id="L214">                                        Thread.sleep(10 * 1000);</span>
<span class="nc" id="L215">                                    } catch (InterruptedException ie) {</span>
<span class="nc" id="L216">                                        LOG.error(&quot;Interrupted while renewing TGT, exiting Login thread&quot;);</span>
<span class="nc" id="L217">                                        return;</span>
<span class="nc" id="L218">                                    }</span>
                                } else {
<span class="nc" id="L220">                                    LOG.warn(&quot;Could not renew TGT due to problem running shell command: '&quot; + cmd</span>
                                            + &quot; &quot; + kinitArgs + &quot;'&quot; + &quot;; exception was:&quot; + e + &quot;. Exiting refresh thread.&quot;,e);
<span class="nc" id="L222">                                    return;</span>
                                }
<span class="nc" id="L224">                            }</span>
                        }
                    }
                    try {
<span class="nc" id="L228">                        int retry = 1;</span>
<span class="nc bnc" id="L229" title="All 2 branches missed.">                        while (retry &gt;= 0) {</span>
                            try {
<span class="nc" id="L231">                                reLogin();</span>
<span class="nc" id="L232">                                break;</span>
<span class="nc" id="L233">                            } catch (LoginException le) {</span>
<span class="nc bnc" id="L234" title="All 2 branches missed.">                                if (retry &gt; 0) {</span>
<span class="nc" id="L235">                                    --retry;</span>
                                    // sleep for 10 seconds.
                                    try {
<span class="nc" id="L238">                                        Thread.sleep(10 * 1000);</span>
<span class="nc" id="L239">                                    } catch (InterruptedException e) {</span>
<span class="nc" id="L240">                                        LOG.error(&quot;Interrupted during login retry after LoginException:&quot;, le);</span>
<span class="nc" id="L241">                                        throw le;</span>
<span class="nc" id="L242">                                    }</span>
                                } else {
<span class="nc" id="L244">                                    LOG.error(&quot;Could not refresh TGT for principal: &quot; + principal + &quot;.&quot;, le);</span>
                                }
<span class="nc" id="L246">                            }</span>
                        }
<span class="nc" id="L248">                    } catch (LoginException le) {</span>
<span class="nc" id="L249">                        LOG.error(&quot;Failed to refresh TGT: refresh thread exiting now.&quot;,le);</span>
<span class="nc" id="L250">                        break;</span>
<span class="nc" id="L251">                    }</span>
<span class="nc" id="L252">                }</span>
<span class="nc" id="L253">            }</span>
        });
<span class="nc" id="L255">        t.setDaemon(true);</span>
<span class="nc" id="L256">    }</span>

    public void startThreadIfNeeded() {
        // thread object 't' will be null if a refresh thread is not needed.
<span class="pc bpc" id="L260" title="1 of 2 branches missed.">        if (t != null) {</span>
<span class="nc" id="L261">            t.start();</span>
        }
<span class="fc" id="L263">    }</span>

    public void shutdown() {
<span class="pc bpc" id="L266" title="3 of 4 branches missed.">        if ((t != null) &amp;&amp; (t.isAlive())) {</span>
<span class="nc" id="L267">            t.interrupt();</span>
            try {
<span class="nc" id="L269">                t.join();</span>
<span class="nc" id="L270">            } catch (InterruptedException e) {</span>
<span class="nc" id="L271">                LOG.warn(&quot;error while waiting for Login thread to shutdown: &quot; + e);</span>
<span class="nc" id="L272">            }</span>
        }
<span class="fc" id="L274">    }</span>

    public Subject getSubject() {
<span class="fc" id="L277">        return subject;</span>
    }

    public String getLoginContextName() {
<span class="fc" id="L281">        return loginContextName;</span>
    }

    private synchronized LoginContext login(final String loginContextName) throws LoginException {
<span class="pc bpc" id="L285" title="1 of 2 branches missed.">        if (loginContextName == null) {</span>
<span class="nc" id="L286">            throw new LoginException(&quot;loginContext name (JAAS file section header) was null. &quot; +</span>
                    &quot;Please check your java.security.login.auth.config (=&quot; +
<span class="nc" id="L288">                    System.getProperty(&quot;java.security.login.auth.config&quot;) +</span>
                    &quot;) and your &quot; + ZooKeeperSaslClient.LOGIN_CONTEXT_NAME_KEY + &quot;(=&quot; + 
<span class="nc" id="L290">                    System.getProperty(ZooKeeperSaslClient.LOGIN_CONTEXT_NAME_KEY, &quot;Client&quot;) + &quot;)&quot;);</span>
        }
<span class="fc" id="L292">        LoginContext loginContext = new LoginContext(loginContextName,callbackHandler);</span>
<span class="fc" id="L293">        loginContext.login();</span>
<span class="fc" id="L294">        LOG.info(&quot;successfully logged in.&quot;);</span>
<span class="fc" id="L295">        return loginContext;</span>
    }

    // c.f. org.apache.hadoop.security.UserGroupInformation.
    private long getRefreshTime(KerberosTicket tgt) {
<span class="nc" id="L300">        long start = tgt.getStartTime().getTime();</span>
<span class="nc" id="L301">        long expires = tgt.getEndTime().getTime();</span>
<span class="nc" id="L302">        LOG.info(&quot;TGT valid starting at:        &quot; + tgt.getStartTime().toString());</span>
<span class="nc" id="L303">        LOG.info(&quot;TGT expires:                  &quot; + tgt.getEndTime().toString());</span>
<span class="nc" id="L304">        long proposedRefresh = start + (long) ((expires - start) *</span>
<span class="nc" id="L305">                (TICKET_RENEW_WINDOW + (TICKET_RENEW_JITTER * rng.nextDouble())));</span>
<span class="nc bnc" id="L306" title="All 2 branches missed.">        if (proposedRefresh &gt; expires) {</span>
            // proposedRefresh is too far in the future: it's after ticket expires: simply return now.
<span class="nc" id="L308">            return System.currentTimeMillis();</span>
        }
        else {
<span class="nc" id="L311">            return proposedRefresh;</span>
        }
    }

    private synchronized KerberosTicket getTGT() {
<span class="nc" id="L316">        Set&lt;KerberosTicket&gt; tickets = subject.getPrivateCredentials(KerberosTicket.class);</span>
<span class="nc bnc" id="L317" title="All 2 branches missed.">        for(KerberosTicket ticket: tickets) {</span>
<span class="nc" id="L318">            KerberosPrincipal server = ticket.getServer();</span>
<span class="nc bnc" id="L319" title="All 2 branches missed.">            if (server.getName().equals(&quot;krbtgt/&quot; + server.getRealm() + &quot;@&quot; + server.getRealm())) {</span>
<span class="nc" id="L320">                LOG.debug(&quot;Found tgt &quot; + ticket + &quot;.&quot;);</span>
<span class="nc" id="L321">                return ticket;</span>
            }
<span class="nc" id="L323">        }</span>
<span class="nc" id="L324">        return null;</span>
    }

    private boolean hasSufficientTimeElapsed() {
<span class="nc" id="L328">        long now = System.currentTimeMillis();</span>
<span class="nc bnc" id="L329" title="All 2 branches missed.">        if (now - getLastLogin() &lt; MIN_TIME_BEFORE_RELOGIN ) {</span>
<span class="nc" id="L330">            LOG.warn(&quot;Not attempting to re-login since the last re-login was &quot; +</span>
                    &quot;attempted less than &quot; + (MIN_TIME_BEFORE_RELOGIN/1000) + &quot; seconds&quot;+
                    &quot; before.&quot;);
<span class="nc" id="L333">            return false;</span>
        }
        // register most recent relogin attempt
<span class="nc" id="L336">        setLastLogin(now);</span>
<span class="nc" id="L337">        return true;</span>
    }

    /**
     * Returns login object
     * @return login
     */
    private LoginContext getLogin() {
<span class="nc" id="L345">        return login;</span>
    }

    /**
     * Set the login object
     * @param login
     */
    private void setLogin(LoginContext login) {
<span class="nc" id="L353">        this.login = login;</span>
<span class="nc" id="L354">    }</span>

    /**
     * Set the last login time.
     * @param time the number of milliseconds since the beginning of time
     */
    private void setLastLogin(long time) {
<span class="nc" id="L361">        lastLogin = time;</span>
<span class="nc" id="L362">    }</span>

    /**
     * Get the time of the last login.
     * @return the number of milliseconds since the beginning of time.
     */
    private long getLastLogin() {
<span class="nc" id="L369">        return lastLogin;</span>
    }

    /**
     * Re-login a principal. This method assumes that {@link #login(String)} has happened already.
     * @throws javax.security.auth.login.LoginException on a failure
     */
    // c.f. HADOOP-6559
    private synchronized void reLogin()
            throws LoginException {
<span class="nc bnc" id="L379" title="All 2 branches missed.">        if (!isKrbTicket) {</span>
<span class="nc" id="L380">            return;</span>
        }
<span class="nc" id="L382">        LoginContext login = getLogin();</span>
<span class="nc bnc" id="L383" title="All 2 branches missed.">        if (login  == null) {</span>
<span class="nc" id="L384">            throw new LoginException(&quot;login must be done first&quot;);</span>
        }
<span class="nc bnc" id="L386" title="All 2 branches missed.">        if (!hasSufficientTimeElapsed()) {</span>
<span class="nc" id="L387">            return;</span>
        }
<span class="nc" id="L389">        LOG.info(&quot;Initiating logout for &quot; + principal);</span>
<span class="nc" id="L390">        synchronized (Login.class) {</span>
            //clear up the kerberos state. But the tokens are not cleared! As per
            //the Java kerberos login module code, only the kerberos credentials
            //are cleared
<span class="nc" id="L394">            login.logout();</span>
            //login and also update the subject field of this instance to
            //have the new credentials (pass it to the LoginContext constructor)
<span class="nc" id="L397">            login = new LoginContext(loginContextName, getSubject());</span>
<span class="nc" id="L398">            LOG.info(&quot;Initiating re-login for &quot; + principal);</span>
<span class="nc" id="L399">            login.login();</span>
<span class="nc" id="L400">            setLogin(login);</span>
<span class="nc" id="L401">        }</span>
<span class="nc" id="L402">    }</span>
}
</pre><div class="footer"><span class="right">Created with <a href="http://www.eclemma.org/jacoco">JaCoCo</a> 0.7.7.201606060606</span></div></body></html>